## ifcopenshell 0.8.1%2Bdfsg1

=== src/ifcblender/Makefile ===
.PHONY: license
license:
	copyright-header --license LGPL3 --copyright-holder "Thomas Krijnen <thomas@aecgeeks.com>" --copyright-year "2022" --copyright-software "IfcBlender" --copyright-software-description "Blender IFC Importer" -a ./ -o ./

.PHONY: qa
qa:
	black .
