=== src/ifccityjson/Makefile ===
# IfcCityJSON - Python CityJSON to IFC converter
# Copyright (C) 2020-2024 Dion Moult <dion@thinkmoult.com>
#
# This file is part of IfcCityJSON.
#
# IfcCityJSON is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# IfcCityJSON is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with IfcCityJSON.  If not, see <http://www.gnu.org/licenses/>.

PACKAGE_NAME:=ifccityjson
include ../common.mk

.PHONY: qa
qa:
	black .
