## ifcopenshell 0.8.1+dfsg1

=== requirements.txt ===
lxml==4.6.3
numpy==1.20.3
regex==2021.4.4
xmlschema==1.6.4
