=== debian/changelog ===
ifcopenshell (0.8.1+dfsg1-1) unstable; urgency=medium

  * Initial packaging. (Closes: #1102034)

 -- Anton Gladky <gladk@debian.org>  Tue, 24 Feb 2026 06:31:04 +0100
