=== debian/control ===
Source: ifcopenshell
Standards-Version: 4.7.3
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Anton Gladky <gladk@debian.org>,
Section: science
Build-Depends:
 dpkg-dev (>= 1.22.5),
 cmake,
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 python3-setuptools,
 libeigen3-dev,
 libhdf5-dev,
 libboost-all-dev,
 libcgal-dev,
 libocct-data-exchange-dev,
 libocct-draw-dev,
 libocct-foundation-dev,
 libocct-modeling-algorithms-dev,
 libocct-modeling-data-dev,
 libocct-ocaf-dev,
 libocct-visualization-dev,
 libsvgpp-dev,
 python3-all-dev,
 swig,
 libaec-dev,
 libxml2-dev,
Vcs-Browser: https://salsa.debian.org/science-team/ifcopenshell
Vcs-Git: https://salsa.debian.org/science-team/ifcopenshell.git
Homepage: https://ifcopenshell.org/

Package: ifcopenshell
Architecture: any
Section: science
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library for working with Industry Foundation Classes (IFC) data
 Complete parsing support is provided for IFC2x3 TC1, IFC4 Add2 TC1, IFC4x1,
 IFC4x2, and IFC4x3 Add2. Extensive geometric support is implemented for the
 IFC releases IFC2x3 TC1 and IFC4 Add2 TC1. Extending with support for arbitrary
 IFC schemas is possible at compile-time when using C++ and at run-time when
 using Python.
 .
 Main package with binaries.

Package: libifcopenshell0.8.1
Architecture: any
Section: science
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library for working with Industry Foundation Classes (IFC) data
 Complete parsing support is provided for IFC2x3 TC1, IFC4 Add2 TC1, IFC4x1,
 IFC4x2, and IFC4x3 Add2. Extensive geometric support is implemented for the
 IFC releases IFC2x3 TC1 and IFC4 Add2 TC1. Extending with support for arbitrary
 IFC schemas is possible at compile-time when using C++ and at run-time when
 using Python.
 .
 Shared library for the ifcopenshell library.

Package: libifcopenshell-dev
Architecture: any
Section: science
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libifcopenshell0.8.1 (= ${binary:Version}),
Description: Library for working with Industry Foundation Classes (IFC) data
 Complete parsing support is provided for IFC2x3 TC1, IFC4 Add2 TC1, IFC4x1,
 IFC4x2, and IFC4x3 Add2. Extensive geometric support is implemented for the
 IFC releases IFC2x3 TC1 and IFC4 Add2 TC1. Extending with support for arbitrary
 IFC schemas is possible at compile-time when using C++ and at run-time when
 using Python.
 .
 Development files for the ifcopenshell library.

Package: python3-ifcopenshell
Architecture: any
Section: python
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libifcopenshell0.8.1 (= ${binary:Version}),
 python3-shapely,
 ${python3:Depends},
Description: Library for working with Industry Foundation Classes (IFC) data
 Complete parsing support is provided for IFC2x3 TC1, IFC4 Add2 TC1, IFC4x1,
 IFC4x2, and IFC4x3 Add2. Extensive geometric support is implemented for the
 IFC releases IFC2x3 TC1 and IFC4 Add2 TC1. Extending with support for arbitrary
 IFC schemas is possible at compile-time when using C++ and at run-time when
 using Python.
 .
 Python bindings for the ifcopenshell library.
