=== debian/rules ===
#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
PY3VER_DEFAULT := $(shell py3versions -dv)

%:
	dh $@ --buildsystem=cmake --sourcedirectory=cmake --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- \
      -DCOLLADA_SUPPORT=Off \
      -DBUILD_SHARED_LIBS=On \
      -DHDF5_SUPPORT=Off \
      -DCGAL_INCLUDE_DIR=/usr/include \
      -DGMP_INCLUDE_DIR=/usr/include \
      -DMPFR_INCLUDE_DIR=/usr/include \
      -DPCRE_LIBRARY_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
      -DGMP_LIBRARY_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
      -DMPFR_LIBRARY_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
      -DJSON_INCLUDE_DIR=/usr/include \
      -DEIGEN_DIR=/usr/include/eigen3

override_dh_dwz:

execute_after_dh_clean:
	rm -rf $(BUILDDIR)
