=== debian/watch ===
version=4
opts=mode=git,gitmode=shallow,pgpmode=none,dversionmangle=s/\+dfsg\d*$// \
https://github.com/IfcOpenShell/IfcOpenShell.git \
refs/tags/ifcopenshell-python-(\d[\d\.]+)
